package com.fp.frontend.controller.armas.solicitud;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.save.DtoSave;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.controller.pgeneral.gene.CatalogDetailController;
import com.fp.frontend.helper.MessageHelper;
import com.fp.frontend.utility.MsgControlArmas;
import com.fp.persistence.parmas.soli.TarmOrdenTrabajoCustodios;
import com.fp.persistence.pgeneral.gene.TgeneCatalogDetail;

@SuppressWarnings("serial")
@ManagedBean
@ViewScoped
public class CustodiosController extends AbstractController<TarmOrdenTrabajoCustodios> {

    //Grados
    List<TgeneCatalogDetail> lGrados = new ArrayList<TgeneCatalogDetail>();
    Boolean salva = false;

    public CustodiosController() throws Exception {
        super(TarmOrdenTrabajoCustodios.class);
    }

    @PostConstruct
    private void postconstruct() {
        this.init();
        // Inicializa autoconsulta
        super.startQuery();

    }

    /**
     * Incializa el controlador, cuando se esta utilizando una pagina que utliza
     * el controlador.
     */
    private void init() {
        try {
            recperpage = 15; // Cambiar al # reg a mirar.
            lrecord = new ArrayList<>();
            beanalias = "CUSTODIOSCONTROLLER";
            this.record = new TarmOrdenTrabajoCustodios();
            record.isnew = true;
            querydatabase();
        } catch (Exception e) {
            MessageHelper.setMessageError(e);
        }
    }

    /**
     * Crea una instancia de TgeneTransactionProcess y marca el registro como
     * nuevo.
     *
     * @throws Exception
     */
    @Override
    public void create() throws Exception {
        super.create();
    }

    @SuppressWarnings("unchecked")
    @Override
    protected void querydatabase() {
        try {
            //Obteniendo la lista de grados militares
            lGrados = CatalogDetailController.find("MILITARYGRADE");

            /*
            DtoQuery dto = super.getDtoQuery(true);            

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(beanalias, dto); // permite adicionar mas de una tabla.

            Request request = callerhelper.getRequest();
            request.setQueryTables(mtables);
            
        	//Obteniendo la lista de grados militares
        	lGrados=CatalogDetailController.find("GRADOS");

            Response resp = callerhelper.executeQuery(request);            

            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                lrecord = new ArrayList<TarmOrdenTrabajoCustodios>();
                MessageHelper.setMessageError(resp);
            } else {
                lrecord = (List<TarmOrdenTrabajoCustodios>) resp.get(beanalias);
                super.postQuery(lrecord);
            }
             */
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void save() {
        try {
            DtoSave dtosave = super.getDtoSave();
            dtosave.setReturnpk(true); // Para que el core devuelva el pk de los registros nuevos.
            HashMap<String, DtoSave> msave = new HashMap<String, DtoSave>();

            Request request = callerhelper.getRequest();
            msave.put(beanalias, dtosave); // adicionar metadata de mantenimiento para cada tabla.

            request.setSaveTables(msave);
            Response resp = callerhelper.executeSave(request);
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) == 0) {
                this.postCommit(resp);
                MessageHelper.setMessageInfo(resp);
            } else {
                MessageHelper.setMessageError(resp);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    public void update(TarmOrdenTrabajoCustodios bean) throws Exception {
        record = bean;
        update();
    }

    public void update(List<TarmOrdenTrabajoCustodios> bean) throws Exception {
        for (TarmOrdenTrabajoCustodios cus : bean) {
            record = cus;
            update();
        }
    }

    @Override
    public void update() throws Exception {
        Boolean duplicada = false;
        if (this.record != null) {
            for (TarmOrdenTrabajoCustodios custodio : this.lrecord) {
                if (custodio.getCedulacustodio().equalsIgnoreCase(this.record.getCedulacustodio())) {
                    duplicada = true;
                }
            }
            if (!this.salva && duplicada) {
                MessageHelper.setMessageError(MsgControlArmas.getProperty("cedulaDuplicada"));
            } else {
                super.update();
            }
        }
    }

    @Override
    public void postCommit(Response response) throws Exception {
        super.postCommitGeneric(response, beanalias);
    }

    /**
     * Devuelve la descripcion de un grado dado su codigo
     *
     * @param gradoCodigo
     * @return
     */
    @SuppressWarnings("finally")
    public String grado(String gradoCodigo) {
        String descripcionGrado = "";

        for (TgeneCatalogDetail cd : lGrados) {
            if (cd.getLegalcode().equalsIgnoreCase(gradoCodigo)) {
                return cd.getDescription();
            }
        }

        return descripcionGrado;
    }

    /**
     * Obtiene todos los custodios
     *
     * @return List<TarmRequisito>
     */
    public static List<TarmOrdenTrabajoCustodios> find() {
        try {
            CustodiosController cc = new CustodiosController();
            cc.init();
            cc.recperpage = 300;
            cc.querydatabase();
            if (cc.lrecord != null && !cc.lrecord.isEmpty()) {
                return cc.lrecord;
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }
    }

    /**
     * Obtiene los custodios de una orden de trabajo
     *
     * @return List<TarmRequisito>
     */
    public static List<TarmOrdenTrabajoCustodios> findByCodigoOrden(Long cordentrabajo) {
        try {
            CustodiosController cc = new CustodiosController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("cordentrabajo", cordentrabajo.toString());
            cc.querydatabase();
            if (cc.lrecord != null && !cc.lrecord.isEmpty()) {
                return cc.lrecord;
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }
    }

    public List<TgeneCatalogDetail> getlGrados() {
        return lGrados;
    }

    public void setlGrados(List<TgeneCatalogDetail> lGrados) {
        this.lGrados = lGrados;
    }

    public Boolean getSalva() {
        return salva;
    }

    public void setSalva(Boolean salva) {
        this.salva = salva;
    }

}
